locations = undefined
parkingmeters = undefined
tariffareas = undefined
url = "https://amsterdam-maps.bma-collective.com/embed/parkeren/deploy_data/"
geojsonGaragesArray = []
geojsonSellPointsArray = []
geojsonTariffArray = []
tarriffAreaPrices = []
##########################################################################
# prep for Mapbox by converting json into geojson
########################################################################
convertGarages = (garages) ->
	#let's transform parkeerlocaties.json into geojson
	for garage in garages.parkeerlocaties
		geolocation = garage.parkeerlocatie
		geoPoint =
			"type": "Feature"
			"geometry": JSON.parse geolocation.Locatie
			"properties":
				"title": geolocation.title,
				"address": geolocation.adres,
				"postalcode": geolocation.postcode
				"description": geolocation.opmerkingen
				"url": geolocation.url
				"type": geolocation.type

		geojsonGaragesArray.push geoPoint

convertParkingmeters = (parkingmeters) ->
	#let's transform parkeermeters.json into geojson
	for parkingmeter in parkingmeters.features
		geoPoint =
			"type": parkingmeter.type
			"geometry": parkingmeter.geometry
			"properties":
				"title": parkingmeter.properties.VERKOOP_PU
				#"adsress": parkingmeter.properties.OMS
				#"description": parkingmeter.properties.B_DAT_VERK
		#print parkingmeter.properties.VERKOOP_PU
		geojsonSellPointsArray.push(geoPoint)

# #let's transform tariffareas.json into geojson
#convertTariffAreas = (tariffareas) ->
#	areaKeys = Object.keys tariffareas
#	for areaKey in areaKeys
#		area = tariffareas[areaKey]
#		_tarriffs = Object.keys area.tarieven
#		#console.log _tarriffs
#		#How many tariffs has one area got?
#		setAmount = () ->
#			size = _tarriffs
#			.length
#			return size
#
#		setTarriff = () ->
#			arr = []
#			for i in _tarriffs
#				arr.push area.tarieven[i]
#			return arr
#
##		valueExist = (el) ->
##			console.log el == area.tarieven[i], el
##			return el == area.tarieven[i]
#
##		do() ->
##			for i in _tarriffs
##				if tarriffAreaPrices.findIndex(valueExist) == -1
##					tarriffAreaPrices.push area.tarieven[i]
##				else
##					console.log "value exists! Values in array: ", tarriffAreaPrices
#		#let's convert into Geojson
#		geoPoint =
#			"type": "Feature"
#			"geometry":
#				"type": "MultiPolygon"
#				"coordinates": area.location.coordinates
#			"properties":
#				"title": area.description["0"]
#				"amount": setAmount()
#				"tarriffs": setTarriff()
#		#console.log geoPoint
#		geojsonTariffArray.push(geoPoint)

getParkingFacilityInformation = (data) ->
	#Ajax -call with SIMPLE PHP PROXY
	#http://benalman.com/code/projects/php-simple-proxy/docs/files/ba-simple-proxy-php.html
	getJSON "./ba-simple-proxy.php?url=https://npropendata.rdw.nl/parkingdata/v2/static/" + data[0].uuid, (data) ->
		if data.status.http_code == 200
			description = data.contents.parkingFacilityInformation.description
			tariffs = data.contents.parkingFacilityInformation.tariffs
			parkingExtensions = data.contents.parkingFacilityInformation.parkingExtensions
			#console.log data.contents.name
			console.log "Total tariffs is " + tariffs.length + " in area " + description
			if parkingExtensions
				console.log "Total parkingExtensions " + parkingExtensions.length + " of " + description
			else
				console.warn "No parkingExtensions!"
		else
			console.error "No data succesfully returned!"

# showMe = (data) ->
# 	console.log data

getUuid = (tariffAreas) ->
	areaUuids = []
	areaKeys = Object.keys tariffAreas
	for areaKey in areaKeys
		uuid = getJSON "https://opendata.rdw.nl/resource/svfa-juwh.json?areamanagerid=363&areaid=" + areaKey, getParkingFacilityInformation

getJSON = (url, callback) ->
	xhr = new XMLHttpRequest()
	xhr.open "GET", url, true
	xhr.setRequestHeader "Content-Type" , "application/x-www-form-urlencoded"
	#bind to load-event doens't work! rdw.nl throws a readystate = 1 -> only opened
	xhr.onreadystatechange = () ->
		if this.readyState == 4
			if this.status == 200
				console.warn this.responseText
#				data = JSON.parse this.responseText
#				if callback != undefined
#					callback(data)
#				else
#					console.warn "No results!"
	xhr.addEventListener "error", () ->
		console.error "Error retrieving data"
	xhr.send()

locations = getJSON url + "locaties.json", convertGarages
parkingmeters = getJSON url + "verkooppunt.json", convertParkingmeters
tariffareas = getJSON url + "tarieven.json", getUuid #convertTariffAreas

# Mapbox-GL-JS
#token Raymond
mapboxgl.accessToken = "pk.eyJ1IjoibXlyYWRvbiIsImEiOiJjaXhwdjJ0b2YwMDI1MzJvZnF1dGlncTE5In0.QyMS4Vd8C9klIWw0Rofj4w"
map = new mapboxgl.Map
	container: "map"
	style: "mapbox://styles/myradon/cixpv422u005o2rph0gmeawzv"
	#style: "mapbox://styles/mapbox/light-v9"
	center: [4.895168, 52.370216]
	zoom: 12
	pitch: 25

map.on "load", (event) ->
	this.addSource "garages",
		type: "geojson"
		data:
			type: "FeatureCollection"
			features: geojsonGaragesArray
		cluster: true
		clusterMaxZoom: 12 #Max zoom to cluster points on
		clusterRadius: 50 #Radius of each cluster when clustering points (defaults to 50)

	this.addSource "parkingmeters",
		type: "geojson"
		data:
			type: "FeatureCollection"
			features: geojsonSellPointsArray

	this.addSource "tariffareas",
		type: "geojson"
		data:
			type: "FeatureCollection"
			features: geojsonTariffArray

	this.addLayer
		"id": "garages"
		"type": "symbol"
		"source": "garages"
		"layout":
			"text-field": "{title}"
			"text-font": ["Open Sans Semibold"]
			"text-size": 20
			"text-offset": [0, 0.5]
			"text-justify": "left"
			"text-anchor": "left"
# 			"paint":
# 				"text-color": "#ff0000"

	this.addLayer
		"id": "parkingmeters",
		"type": "symbol",
		"source": "parkingmeters",
		"layout":
			"text-field": "{title}",
			"text-font": ["Open Sans Regular"],
			"text-size": 16,
			"text-anchor": "center"
# 			"paint":
# 				"text-color": "#0000ff"

	this.addLayer
		"id": "tariffareas"
		"type": "fill"
		"source": "tariffareas"
		"paint":
			"fill-color": "#ff0000"
			"fill-opacity": 0.3

# 		#get coordinates of garages from JSON-file
# 		garageCoordinates = (location) ->
# 			geo = []
# 			#Get coordinates string by stripping not applicable characters and split the coordinate-string at the comma
# 			coordinates = location.parkeerlocatie.Locatie
# 			.slice 31, -2
# 			.split ','
# 			#convert String to Number and push into Array
# 			geo.push Number coordinates[0]
# 			geo.push Number coordinates[1]
# 			return geo
#
# 		for location, i in locations.parkeerlocaties
# 			#create a DOM element for the marker. Marker is styled with CSS
# 			el = document.createElement "div"
# 			el.className = "garage-icon"
# 			el.id = "garage-icon-" + i
# 			#print el.id
#
# 			el.addEventListener "tap", () ->
# 				print "icon clicked " + @.classList
#
# 			#add marker to map
# 			coordinates = garageCoordinates(location)
# 			new mapboxgl.Marker el , {offset: [-70, -20]}
# 			.setLngLat coordinates
# 			.addTo map

##########################################################################
# search input Maps
########################################################################
search = document.querySelector '#search'
search.addEventListener "keypress", (event) ->
	if event.keyCode is 13
		event.preventDefault()
		target = search.value
		target = convertLocation(target)
		#let's fecth coordinates of location and when done fly to these coordinates
		getGeoCoordinates(target, setNewLocation)

convertLocation = (target) ->
	#Dutch postal code
	pattern = new RegExp /^[1-9][0-9]{3} ?(?!sa|sd|ss)[a-z]{2}$/i
	if pattern.test target
		#print "Ja een postcode!"
		return target
	else
		#Test if input ends with Amsterdam
		pattern = new RegExp /(amsterdam)$/i
		if pattern.test target
			#print "Eindigt met Amsterdam"
			return target
		else
			#print "Eindigt niet met Amsterdam"
			return target + " Amsterdam"

#Fly to new location
setNewLocation = (location) ->
	map.flyTo
		center: location.coordinates
		zoom: 19
		bearing: 5
		speed: 0.75
		curve: 2.5

#GoogleApiKey = "AIzaSyC9fs1w38B6SMxUUdIAS7RfCJnhXzxr4go"
#Do API-call to Google Maps API. It can convert addresses, postalcodes, cities
#into Longitude and lattitude. When Ajax-call is sussesful a calbback function will be executed
getGeoCoordinates = (data, callback) ->
	data = data.replace /\s/g, '+'
	url = "http://maps.google.com/maps/api/geocode/json?address=" + data + "&sensor=false"
	result =
		coordinates: []
		status: undefined

	xhr = new XMLHttpRequest()
	xhr.open "GET", url
	xhr.addEventListener "load", () ->
		if xhr.status == 200
			location = JSON.parse xhr.responseText
			#when there are results push geolocations
			if location.results.length
				result.coordinates.push location.results[0].geometry.location.lng, location.results[0].geometry.location.lat
				result.status = location.status
				#Okay we're ready let's eccucute callback-funtion with result
				callback(result)
			else
				print "No results for typed location!"
				result.states = "no results"
	xhr.addEventListener "error", () ->
		print "error retrieving data with Maps-call"
		result.status = "error"
	xhr.send()
